# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class TaxReturnPersonal(pydantic.BaseModel):
    id: typing.Optional[str] = pydantic.Field(
        description=("Unique identifier created by Belvo used to reference the current Tax Return.\n")
    )
    link: typing.Optional[str] = pydantic.Field(description=("The `link.id` the statement belongs to\n"))
    collected_at: typing.Optional[str] = pydantic.Field(
        description=("The ISO-8601 timestamp when the data point was collected.\n")
    )
    created_at: typing.Optional[str] = pydantic.Field(
        description=("The ISO-8601 timestamp of when the data point was last updated in Belvo's database.\n")
    )
    informacion_general: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description=(
            "General information on the tax return (year, RFC, return type, person/company name, and so on).\n"
        )
    )
    sueldos_salarios: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description=("Details regarding the income information together combined with withheld taxes.\n")
    )
    servicios_profesionales: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description=("Details regarding the income and tax information from professional services provided.\n")
    )
    deducciones_personales: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description=("List of all personal tax deductions.\n")
    )
    determinacion_impuesto: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description=("Details regarding the final tax return.\n")
    )
    retenciones: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description=("Details on the already withheld taxes.\n")
    )
    dividendos: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description=("Details regarding dividends.\n")
    )
    datos_informativos: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description=("Extra informative data on the tax return.\n")
    )
    pdf: typing.Optional[str] = pydantic.Field(description=("Tax return PDF as a binary.\n"))
    receipt_pdf: typing.Optional[str] = pydantic.Field(
        description=(
            "The acknowledgement receipt from the fiscal institution confirming that they received the tax return.\n"
        )
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
